package org.dromara.inspection.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.dromara.inspection.domain.bo.OpsInspectionItemBo;
import org.dromara.inspection.domain.vo.OpsInspectionItemVo;
import org.dromara.inspection.domain.OpsInspectionItem;
import org.dromara.inspection.mapper.OpsInspectionItemMapper;
import org.dromara.inspection.service.IOpsInspectionItemService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 运维-巡检-自定义巡检项Service业务层处理
 *
 * @author LionLi
 * @date 2025-09-19
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class OpsInspectionItemServiceImpl implements IOpsInspectionItemService {

    private final OpsInspectionItemMapper baseMapper;

    /**
     * 查询运维-巡检-自定义巡检项
     *
     * @param id 主键
     * @return 运维-巡检-自定义巡检项
     */
    @Override
    public OpsInspectionItemVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询运维-巡检-自定义巡检项列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 运维-巡检-自定义巡检项分页列表
     */
    @Override
    public TableDataInfo<OpsInspectionItemVo> queryPageList(OpsInspectionItemBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<OpsInspectionItem> lqw = buildQueryWrapper(bo);
        Page<OpsInspectionItemVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的运维-巡检-自定义巡检项列表
     *
     * @param bo 查询条件
     * @return 运维-巡检-自定义巡检项列表
     */
    @Override
    public List<OpsInspectionItemVo> queryList(OpsInspectionItemBo bo) {
        LambdaQueryWrapper<OpsInspectionItem> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<OpsInspectionItem> buildQueryWrapper(OpsInspectionItemBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<OpsInspectionItem> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(OpsInspectionItem::getId);
        lqw.eq(bo.getProjectId() != null, OpsInspectionItem::getProjectId, bo.getProjectId());
        lqw.like(StringUtils.isNotBlank(bo.getName()), OpsInspectionItem::getName, bo.getName());
        lqw.eq(StringUtils.isNotBlank(bo.getType()), OpsInspectionItem::getType, bo.getType());
        return lqw;
    }

    /**
     * 新增运维-巡检-自定义巡检项
     *
     * @param bo 运维-巡检-自定义巡检项
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(OpsInspectionItemBo bo) {
        OpsInspectionItem add = MapstructUtils.convert(bo, OpsInspectionItem.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改运维-巡检-自定义巡检项
     *
     * @param bo 运维-巡检-自定义巡检项
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(OpsInspectionItemBo bo) {
        OpsInspectionItem update = MapstructUtils.convert(bo, OpsInspectionItem.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(OpsInspectionItem entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除运维-巡检-自定义巡检项信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
